# Jspxcms 发版说明

## jspxcms-10.2.0 (2021-01-27)

1. 默认模板视频播放器升级为`video.js`，无需flash支持。
2. 默认模板文库浏览器升级为`pdf.js`，无需flash支持。
3. 修复固定会话攻击漏洞。

## jspxcms-10.1.0 (2020-12-20)

1. 优化访问统计。对每日访问日志进行归总，并自动删除30天前访问日志，避免访问量大导致访问日志剧增。
2. 将访问统计图表放回后台首页。

## jspxcms-10.0.0 (2020-10-15)

1. 升级至`jdk 8`。
2. 升级至`shiro 1.6.0`。
3. 修复`InfoDao`里的SQL语句多了一个括号。
4. 增加自适应模板，可以自动支持PC和手机浏览器。
5. 增加视频播放器`video.js`的演示，无需flash支持。
6. 增加文库浏览器`pdf.js`的演示，可以直接浏览PDF文件，无需flash支持。
7. application.properties里加上`spring.jta.enabled=false`配置，防止在WebSphere里报`UnsupportedOperationException`错误。
8. 模板`sys_member_contribution_list.html`删除投稿操作必须使用`POST`方式提交。
9. 模板`app_info_favorites.html`收藏和取消收藏必须使用`POST`方式提交。
10. 由于 commons lang 类库版本升级，导致fnx.tld文件中某些方法被废弃，注释掉已被废弃的方法。
11. 去除`InfoController`和`NodeController`的`template`参数。
12. 过滤模板参数中非法字符。
13. 过滤文件管理中重命名和修改的非法字符。
14. 用户管理增加`csrf token`。
15. 修复文档移动405错误。
16. 修复站点导入时`DOCTYPE`的识别。
17. 删除加密工具类中无用代码。
18. 后台首页的访问量图表移到系统信息里，降低后台访问的压力。

## jspxcms-9.5.1 (2019-07-27)

1. 文件管理save权限将`save@web_file_x:save`修正为`save@core:web_file_x:save`。
2. 修复文档管理中正文编辑器保存视频时，会过滤掉视频代码的问题。
3. 将站点导入允许的格式由xml改为zip。
4. 将MemberGroup的nodeGroups集合，由Set改为List。因为Set在add时会遍历所有元素的equals方法，导致延迟加载失效。
5. doc导入按钮选择文件时，默认文件格式由docx改为doc和docx。
6. 增加模板异常不写入日志的配置示例。
7. 修复站群推送列表翻页跳转文档列表的问题。
8. 数据库配置文件增加数据库用户名密码示范，避免使用者误认为需要保留大括号。

## jspxcms-9.5.0 (2019-03-19)

1. 默认限制上传文件的后缀。
2. 默认取消文件管理功能。
3. 彻底取消前台对jsp的支持。
4. 禁止对本机抓取图片限制，抓取图片只支持http和https协议。
5. 对后台选择功能（栏目选择、模板选择）增加权限控制。
6. 后台保存和修改数据只能使用POST提交。
7. 增加CSRF过滤器，可以限制只接受指定域名的POST请求提交。
8. 角色管理功能如果勾选了所有权限，则选择按钮禁用。

## jspxcms-9.0.0 (2018-05-14)

### 新功能(New Feature)

1. 新增站点间推送功能。
2. 新增微信jssdk分享功能。
3. 新增站点导入导出功能。

### 改进(Improvement)

1. 站点复制功能可以复制所有模板、模型、栏目和文档。
2. 站点独立配置微信公众号。
3. 将flash上传组件改为jquery上传组件。


## jspxcms-8.0.4 (2018-04-18)

### 改进(Improvement)

1. 支持在手机浏览器访问PC页面。
2. 关闭spring-boot自带的favicon。

### 缺陷(Bug)

1. 修复：投票管理修改时，新增投票项报错。
2. 修复：微信群发页面js效果无效。
3. 修复：采集管理下载地址自动补全。
4. 修复：采集管理对所有url地址进行unescape。
5. 修复：私信、通知sql的where exists去掉表的别名。
6. 修复：手机端url在没有手机端域名时会为null。
7. 修复：SQLServer新驱动需要修改substring参数为三个。
8. 修复：后台系统消息管理权限值有误。
9. 修复：后台采集定时任务在tomcat-8.5.24版本中会出错。
10. 修复：没有审核权限的文档不允许移动。
11. 修复：通知列表页排序报错。


## jspxcms-8.0.3 (2017-10-25)

### 改进(Improvement)

1. 安全升级。

### 缺陷(Bug)

2. 修复：后台首页中上次登录时间不更新。


## jspxcms-8.0.2 (2017-09-29)

### 改进(Improvement)

1. 后台登录页面禁止密码自动完成。否则浏览器会提示是否保存密码，部分安全扫描软件会认定为漏洞。

### 缺陷(Bug)

1. 修复：系统通知和我的私信在oracle下报错。
2. 修复：工作流步骤修改时报错。
3. 修复：删除有嵌套评论（评论盖楼）的文章报错。
4. 修复：栏目移动报错。
5. 修复：栏目合并提交报错。
6. 修复：前台信息提示页nextUrl的跨站攻击问题。
7. 修复：后台登录页面用户名跨站攻击问题。


## jspxcms-8.0.1 (2017-06-21)

### 改进(Improvement)

1. 在站点设置里可以增加手机模板修改，不用到站点管理里修改。
2. sql脚本增加commit语句，避免因为执行脚本时为提交导致数据没有正确插入。
3. pom.xml里增加tomcat7启动插件，方便希望使用tomcat7插件启动的用户。
4. 文档管理自动获取描述长度增加到最长的450字符。
5. 友情链接列表logo限制大小，避免logo尺寸过大导致页面显示不好看。
6. InfoPage和NodePage标签增加p0参数。
7. 升级MySQL驱动，支持MySQL5.7。

### 缺陷(Bug)

1. 修复：后台右上角小房子图标的前台首页链接在多站点情况下，切换站点后无变化。
2. 修复：文档管理标题图、属性图、图集在火狐下点击上传按钮无反应。
3. 修复：文件管理搜索功能没有保留当前文件夹路径。
4. 修复：后台左侧菜单没有屏蔽无权限的菜单。
5. 修复：开启页面静态化后，某些栏目生成了HTML，但还会显示HTML待更新。
6. 修复：文档管理doc上传按钮位置不正确。
7. 修复：有上下文路径时，站点静态首页地址多了一个上下文路径。
8. 修复：谷歌某些版本的浏览器点击文档管理图片选择按钮无效。
9. 修复：后台任务管理翻页列表固定不变。
10. 修复：修改组织报错。


## jspxcms-8.0.0 (2017-04-19)

### 新功能(New Feature)

1. 使用springboot框架。
2. 前台使用restful风格地址，去掉url地址后缀。
3. 支持多平台访问。同一站点可分别指定PC端模板和手机端模板。并支持PC端、手机端同时生成静态页。
4. 新增一键启用、关闭静态化功能。
5. 后台界面美化。
6. 新增用户模型。
7. 前台增加站内信、通知、收藏功能。
8. 升级到JDK7、Servlet3.0（Tomcat7或更高版本）。

### 改进(Improvement)

1. 前台会员投稿可发布图片集、视频等内容。
2. 后台菜单使用yaml格式文件存储，结构更清晰，维护更方便。
3. 去掉URL带域名设置，勾选域名识别则自动URL带域名。
4. 去掉安装功能。部署时手动导入数据。

### 升级指南（Upgrade Guide）

1. 搜索模板的`.jspx'` `.jspx"` `.jspx%` `.jspx;` `.jspx&` `.jspx<` `.jspx?`（如直接搜索`.jspx`，会匹配到`.jspxcms...`），替换掉其中的`.jspx`。
2. 搜索模板的`.servlet'` `.servlet"` `.servlet?`，替换掉其中的`.servlet`。
3. 取消手动设置默认站点，站点ID为1的为默认站点。
4. 系统后台浏览器支持IE9+，需要使用IE8的用户请使用7.X版本。


## jspxcms-7.0.2-release (2017-03-24)

### 改进(Improvement)

1. 文章正文中小于100px的图片不作为标题图。
2. 会员中心头像图片增加时间戳参数，避免因为缓存导致修改头像后无变化。
3. 创建站点时，同时复制首页栏目，以免在未创建首页栏目时，访问首页出现node not found: root。
4. 删除站点时，同时删除空栏目。

### 缺陷(Bug)

1. 修复：调查问卷限制会员投票无效。
2. 修复：设置了编辑器图片最大宽度，而最大高度为0是会报错。
3. 修复：会员中心上传头像时，不裁剪图片直接提交会报错。
4. 修复：部分关联表数据删除后，index顺序未调整，有可能导致文档或用户相关功能报错。
5. 修复：删除站点时，提示违反数据约束。


## jspxcms-7.0.1-release (2017-01-20)

### 改进(Improvement)

1. 访问统计中，饼图改进为只显示前10位，剩余的作为其他显示。

### 缺陷(Bug)

1. 修复：文档管理修改时分部默认数据会报错的问题（数据库初始化数据导致的问题）。
2. 修复：访问统计中的菜单没有全部加上。
3. 修复：访问统计中，URL地址包含空格会报错。
4. 修复：获取部分IP的实际地址会报错。
5. 修复：搜索中文时，出现乱码。


## jspxcms-7.0.0-release (2016-12-26)

### 新功能(New Feature)

1. 文档录入增加doc导入功能，可以导入doc里面的图片，避免一张张上传。
2. 增加找回密码邮件的有效期，超过8小时失效。
3. 增加角色等级，用户不可以被赋予比自身等级更高的角色，避免拥有用户管理权限的人员提升自己的权限。
4. 采集增加是否采集正文图片选项。
5. 增加栏目权限控制，用户无法访问没有权限的栏目。
6. 增加通过IP地址获取真实位置的功能。
7. 后台浏览统计通过图表显示。
8. 后台增加站内信功能。
9. 支持使用ImageMagick或GraphicsMagick处理图片。比纯Java效果更好、效率更高，并支持gif图压缩。

### 改进(Improvement)

1. 使用maven生成QueryDSL查询类。
2. 升级ueditor-1.4.3.3。

### 缺陷(Bug)

1. 修复editor.md编辑器光标定位不准问题。

### 升级指南（Upgrade Guide）

1. **升级ueditor-1.4.3.3**，前台投稿模板中ueditor编辑器调用方式需修改，请参照默认模板同名文件修改`/template/1/default/sys_member_contribution_form.html`。


## jspxcms-6.5.4-release (2016-12-22)

### 缺陷(Bug)

1. 修复：附件管理点击“是否使用”列头排序会报错。
2. 修复：文档管理对HTML过滤会导致一些正常的HTML无法录入。取消过滤。
3. 修复：editormd无法上传图片。
4. 修复：ueditor上传图片最大为4M，以及超过2M的图片会压缩。全部修改为100M。
5. 修复：InfoList(InfoPage)的isPerm参数无效。
6. 修复：前台投稿编辑器上传图片提示网络错误。


## jspxcms-6.5.3-release (2016-11-02)

### 改进(Improvement)

1. 用户不能删除自己。
2. 增加专题的浏览次数功能。
3. 图集原图如不需要压缩则不要处理，避免导致gif图动态效果消失。

### 缺陷(Bug)

1. 修复：微信登录没有显示微信名，微博登录StateIllegalException异常。
2. 修复：投稿修改的正文直接显示html。
3. 修复：发送邮件报错，没有mail的实现jar包。
4. 修复：采集是否允许标题重复，没有验证、没有默认值。
5. 修复：没有用户批量删除权限的未屏蔽按钮。
6. 修复：前台头像剪裁在特定情况下由于浮点运算误差，导致剪裁高度大于原图，出现异常。
7. 修复：文库转换不支持docx。


## jspxcms-6.5.2-release (2016-08-10)

### 改进(Improvement)

1. MySQL驱动改为5.1.24，兼容MySQL5.1。
2. 游客组、匿名用户、根用户不能被删除。
3. 默认模板cover_news.html不固定获取news栏目的子栏目。
  
### 缺陷(Bug)

1. 修复：调查问卷-修改调查项-保存并返回，出现404错误。


## jspxcms-6.5.1-release (2016-07-25)

### 改进(Improvement)

1. 敏感词的替换词允许为空。
2. javassist版本降低为hibernate依赖的版本3.18.1，避免部分小版本较低的tomcat报错。
  
### 缺陷(Bug)

1. 修复：文档管理产品介绍正文没有显示内容。
2. 修复：新建站点后，创建首页栏目报错。
3. 修复：采集管理，新增报错。


## jspxcms-6.5.0-release (2016-07-07)

### 新功能(New Feature)

1. 开源版开放多站点功能。
2. 增加手机端网站演示。
3. 增加微信公众号群发新闻功能。
4. 增加微信第三方登录。
4. 文档管理增加markdown编辑器。
5. 文档管理加上按发布人、作者搜索。
6. 采集时，允许勾选采集标题重复的内容。

### 改进(Improvement)

1. 使用maven管理。
2. 第三方类库版本升级。servlet升级为2.5，spring升级为4.2.x，jpa升级为2.1，hibernate升级为5.0.x，spring-data-jpa升级为1.9.x。
3. 删除文档相关数据时，如果回收站有数据，则自动删除。
4. 删除站点时，自动删除模型。
5. 后台发生400错误时，提供更详细的信息，更便于二次开发时查找问题。
6. 裁剪不删除原图片。
	
### 缺陷(Bug)

1. 前台swfupload增加jsessionid，防止上传时无法获得用户身份信息。
2. “系统设置 - 注册设置”里会员组选项不显示“游客组”。
3. 修复前台登录时，如果上下文路径不为空，则返回地址会出错。
4. 默认模版/template/1/default/info_video.html，42行，`c:0，`改为`c:0,`（中文逗号改为英文逗号）。
5. 修复默认会员中心模版修改头像页面的标题显示为修改邮箱。
6. 修复删除站点时，任务数据未删除。
7. 修复广告图片上传会被标识为未使用。

### 升级指南（Upgrade Guide）

1. **第三方登录URL地址修改。**`/oauth/qq_login.jspx`改为`/oauth/login/qq.jspx`；`/oauth/weibo_login.jspx`改为`/oauth/login/weibo.jspx`。
2. **编辑器工具条`tarbar_Cms`改为`tarbar_Standard`。**
3. **专题类别模版和URL地址修改。**`/specials.jspx`改为`/special_category.jspx`，`/specials/{id}.jspx`改为`/special_category/{id}.jspx`，`sys_specials.html`改为`sys_special_category_list.html`，`sys_specials_list.html`改为`sys_special_category.html`。
4. **Tag模版和URL地址修改。**`/tags.jspx`改为`/tag.jspx`，`/tags/{id}.jspx`改为`/tag/{id}.jspx`；`sys_tags.html`改为`sys_tag_list.html`。
5. **配置文件路径修改。**`/WEB-INF/conf`改为`/WEB-INF/classes/conf`，**国际化文件路径**`/WEB-INF/messages`改为`/WEB-INF/classes/messages`，**数据库连接文件**`/WEB-INF/custom.propertis`改为`/WEB-INF/classes/custom.propertis`。
6. **执行数据库升级脚本：upgrade-6.0to6.5.sql。**


## jspxcms-6.0.1-release (2016-02-22)

### 改进(Improvement)

1. 第三方登录完善账户信息时允许不填写密码和验证码。
2. 广告管理图片为必填项。
3. 修正新浪采集演示数据。
	
### 缺陷(Bug)

1. 文件管理列表页面底部显示图片时，图片定位不准。
2. 广告管理新增广告时报错。
3. oracle版文档管理新增文档，如保存正文为空，更新正文不为空，则cms_info_clob表会出现两条记录。
4. 栏目移动提交时出现404错误。


## jspxcms-6.0.0-release (2015-12-25)

### 新功能(New Feature)

1. 调查问卷。
2. 会员头像、会员空间。
3. 评论盖楼、评论点赞。
4. QQ、微博第三方登录。
5. 高级搜索，关键词高亮。
6. 可查询字段演示。
7. 文档、栏目可查询字段增加p0。
8. 缓存的刷新触发设置。
9. 登录需要验证码的错误次数设置。
10. 演示模版升级。
	
### 改进(Improvement)

1. 编辑器正文图片默认不压缩。
2. 文档列表增加彻底删除链接。
3. 增加关键词分割符设置。
4. 优化word转swf程序。
5. 文档属性图片改为必填项。
6. 后台所有操作都记录日志。
7. 全文检索查询参数q增加关键字和描述的搜索。
8. 文档修改页面取消转向链接复选框自动清空转向链接内容。
	
### 缺陷(Bug)

1. ueditor上传附件302错误（在火狐下）。
2. ueditor双引号转义的问题。
3. ueditor粘贴表格问题（在谷歌浏览器下）。
4. ueditor上传附件不显示类型图标。
5. 用户注册验证邮件地址错误。
6. 专题无法选择模版。
7. 新增广告在没有广告版位时会报错。
8. 日志查询操作人没有保留。
9. swfupload上传中点取消无效。


	
	